<template>
  <div>
    <el-card class="box-card">
      <el-row style="padding:0;">
        <el-col class="chat-wrap" id="chat-wrap" style="overflow-y: scroll">
          <el-card v-for="(d, index) in discuss" :key="index" class="chat">
            <!-- 강사의 채팅 -->
            <div v-if="d.is_teacher === 1">
              <div class="chat-head">
                <div>
                  <span style="color: blue; font-weight: bold; font-size: 0.8em">{{ d.user.name }}</span>
                  <span style=" font-size: 0.3vw">({{ d.created_at }})</span>
                </div>
                <div style="margin-top: 0.5%">
                  <span style=" font-size: 0.8em">{{ d.content }}</span>
                </div>
              </div>
            </div>
            <!-- 학생의 채팅 -->
            <div v-else>
              <div class="chat-head">
                <div>
                  <span style="color: green; font-weight: bold; font-size: 0.8em">{{ d.user.name }}</span>
                  <span style=" font-size: 0.3vw">({{ d.created_at }})</span>
                </div>
                <div style="margin-top: 0.5%">
                  <span style=" font-size: 0.8em">{{ d.content }}</span>
                </div>
              </div>
            </div>
          </el-card>
        </el-col>
      </el-row>
      <hr style="margin-left: -20px; margin-right: -20px">
      <el-row style="padding:0;">
        <el-col>
          <el-form @submit.native.prevent :inline="true" label-width="0px" class="chat-msg-box">
            <el-form-item class="chat-msg">
              <el-input
                v-if="$isPhone"
                class="input-chat"
                type="textarea"
                :rows="2"
                v-model="msg"
                :maxlength="limitLength"
                @keyup.enter.native="chatSubmit"
                show-word-limit>
              </el-input>
              <el-input
                v-if="!$isPhone"
                class="input-chat"
                type="textarea"
                :rows="2"
                v-model="msg"
                :maxlength="limitLength"
                @keyup.enter.native="chatSubmit"
                show-word-limit>
              </el-input>
            </el-form-item>
            <el-form-item>
              <div class="box">
                <el-button type="primary" @click="chatSubmit" size="small">{{ $t('DASHBOARD.ENTER') }}</el-button>
                <el-button v-if="authType === 1" @click="exportToExcel" size="small">{{ $t('DASHBOARD.REALTIME_CHAT_DOWNLOAD') }}</el-button>
                <el-button v-if="authType === 1" @click="dialogVisible = true" size="small">{{ $t('DASHBOARD.REALTIME_CHAT_DEL') }}</el-button>
                <el-button v-if="authType === 0" type="primary" @click="requestCall" size="small">{{ $t('STUDENT_MENU.ONE_TO_ONE') }}</el-button>
                <el-button v-if="authType === 0 && portraitOrLandscape === 'portrait'" @click="onClick('MATRIALCHECK')" size="small">{{ $t('MATERIAL.MAT') }} </el-button>
              </div>
              <el-button :key="canStartFaceRecognition" v-if="authType === 0 && lecture.webcam_link === ''" size="small" @click="$listeners['face_recognition'](true)" :disabled="!canStartFaceRecognition">{{ $t('REALTIME.TEST_FACE_RECOG') }}</el-button>
              <el-button v-if="authType === 0 && lecture.webcam_link !== ''" size="small" @click="openInNewTab(lecture.webcam_link)">{{ $t('REALTIME.ACCESS_REALTIME_VIDEO_SESSION') }}</el-button>
              <el-button v-if="authType === 0 && (portraitOrLandscape === 'landscape' || !$isPhone)" @click="onClick('MATRIALCHECK')" size="small">{{ $t('MATERIAL.MAT') }} </el-button>
              <el-button v-if="authType === 0" @click="onClick('SGROUP')" size="small">{{ $t('REALTIME.SGROUP') }} </el-button>                            
            </el-form-item>
          </el-form>
        </el-col>
      </el-row>
    </el-card>
    <!--
    <realtime-webcam-lecture-student
      v-if="authType === 0"
    />
    -->
    <el-dialog
      title="Info"
      :visible.sync="dialogVisible"
      :close-on-click-modal="false"
      :show-close="false"
      width="360px">
      <span>{{ $t('NOTIFY.CHAT_DELETE') }}</span>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="deleteChat">{{ $t('STUDENT_LECTURE.YES') }}</el-button>
        <el-button type="primary" @click="dialogVisible = false">{{ $t('STUDENT_LECTURE.NO') }}</el-button>
      </span>
    </el-dialog>

    <el-dialog
      :visible.sync="materialVisible"
    >
      <lecture-live-material
      :materialList="materialList"
      :presentMaterial="presentMaterial"
      />
    </el-dialog>
    
    <!-- 채팅 내용 엑셀 다운로드를 위한 임시 테이블 -->
    <table id="chat" :data="discuss">
      <thead v-show="lectureId < 0">
        <tr>
          <td>name</td>
          <td>email</td>
          <td>content</td>
          <td>date</td>
        </tr>
      </thead>
      <tbody v-show="lectureId < 0">
        <tr v-for="(k, index) in discuss" :key="index">
          <td>{{ k.user.name }}</td>
          <td>{{ k.user.email_id }}</td>
          <td>{{ k.content }}</td>
          <td>{{ k.created_at }}</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>


<style scoped>
  :root {
    --box-width: 100px;
    --box-height: 100px;
    --chat-height: 100px;
    --input-chat-width: 100px;
  }
  .box-card {
    width: var(--box-width);
    height: var(--box-height);
  }
  .chat-msg {
    margin-bottom: 0;
  }
  .chat {
    margin: 2px 2px 2px 0;
  }
  .chat-date {
    float: right;
    color: #aaaaaa;
  }
  .chat-head {
    margin: -10px -10px -10px -10px;
  }
  .chat-wrap {
    height: var(--chat-height);
  }
  .input-chat {
    width: var(--input-chat-width);
  }
  .box {
    display: flex;
    margin: 10px 0px 0px 0px;
  }
</style>

<script>
  import { mapGetters, mapMutations, mapState } from 'vuex';
  import TableExport from 'tableexport';
  import utils from '../../utils';
  import lectureChatingService from '../../services/lectureChatingService';
  import RealtimeWebcamLectureStudent from '../pages/RealtimeWebcamLectureStudent';
  import lectureService from '../../services/lectureService';
  import LectureLiveMaterial from '../partials/LectureLiveMaterial';

  export default {
    name: 'LectureChating',
    props: ['canStartFaceRecognition'],
    async created() {
      const vm = this;
      const params = {
        lecture_id: vm.lectureId,
      };
      vm.$socket.emit('JOIN_CHAT', JSON.stringify(params));
      
      let width = window.innerWidth || document.body.clientWidth;
      let height = window.innerHeight || document.body.clientHeight;
      if (vm.authType === 0) { // 학생인 경우에만 변경
        // 모바일인 경우
        if (vm.authType === 0 && vm.$isPhone) {
          if (width > height) { // 가로모드
            vm.portraitOrLandscape = 'portrait';
            vm.displaySize.width = `${width * 0.8 * 0.88}px`;
            vm.displaySize.height = `${(width * 0.8) * 0.5}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.6) * 0.3}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          } else {  // 세로모드
            vm.portraitOrLandscape = 'landscape';
            vm.displaySize.width = `${width * 0.8 * 0.85}px`;
            vm.displaySize.height = `${(width * 0.8) * 1.1}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.4) * 0.8}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          }
        } else {  // PC인 경우
          vm.displaySize.width = `${width * 0.8 * 0.265}px`;
          vm.displaySize.height = `${((width * 0.8 * 0.675) / 16 * 9)}px`;
          vm.displaySize.chatHeight = `${((width * 0.8 * 0.675) / 16 * 9) * 0.6}px`;
          vm.displaySize.inputChatWidth = `${width * 0.8 * 0.265 * 0.85}px`;
        } 
      } else {
        vm.displaySize = {
          width: '400px',
          height: '390px',
          chatHeight: '220px',
          inputChatWidth: '360px',
        }
      }
      
      document.documentElement.style.setProperty('--box-width', vm.displaySize.width);
      document.documentElement.style.setProperty('--box-height', vm.displaySize.height);
      document.documentElement.style.setProperty('--chat-height', vm.displaySize.chatHeight);
      document.documentElement.style.setProperty('--input-chat-width', vm.displaySize.inputChatWidth);

      const res3 = await lectureService.getLectureMaterial({
        lectureId: vm.lectureId,
      });
      vm.materialList = res3.data;
    },
    async mounted() {
      const vm = this;

      // 새 채팅 온 경우
      window.addEventListener('resize', function() {
        if (vm.authType === 0) { // 학생인 경우에만 변경
          let width = window.innerWidth || document.body.clientWidth;
          let height = window.innerHeight || document.body.clientHeight;
          
          // 모바일인 경우
          if (vm.authType === 0 && vm.$isPhone) {
            if (width > height) { // 가로모드
            vm.portraitOrLandscape = 'portrait';
            vm.displaySize.width = `${width * 0.8 * 0.88}px`;
            vm.displaySize.height = `${(width * 0.8) * 0.5}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.6) * 0.3}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          } else {  // 세로모드
            vm.portraitOrLandscape = 'landscape';
            vm.displaySize.width = `${width * 0.8 * 0.85}px`;
            vm.displaySize.height = `${(width * 0.8) * 1.1}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.4) * 0.8}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          }
          } else {  // PC인 경우
            vm.displaySize.width = `${width * 0.8 * 0.265}px`;
            vm.displaySize.height = `${((width * 0.8 * 0.675) / 16 * 9)}px`;
            vm.displaySize.chatHeight = `${((width * 0.8 * 0.675) / 16 * 9) * 0.6}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.265 * 0.85}px`;
          }
          document.documentElement.style.setProperty('--box-width', vm.displaySize.width);
          document.documentElement.style.setProperty('--box-height', vm.displaySize.height);
          document.documentElement.style.setProperty('--chat-height', vm.displaySize.chatHeight);
          document.documentElement.style.setProperty('--input-chat-width', vm.displaySize.inputChatWidth);
        }
      }, true);
      vm.sockets.subscribe('ARRIVE_NEW_CHAT', (msg) => {
        const jsonMSG = JSON.parse(msg);
        jsonMSG.created_at = utils.formatDate(new Date(jsonMSG.created_at));
        vm.discuss.push(jsonMSG);
        if (jsonMSG.user_id === null) {
          vm.$notify({
            title: '알 수 없음',
            message: jsonMSG.content,
            type: 'info',
          });
        } else if (jsonMSG.user_id === utils.getUserIdFromJwt()) {
          vm.updating = false;
        } else {
          vm.$notify({
            title: jsonMSG.user.name,
            message: jsonMSG.content,
            type: 'info',
          });
        }
        vm.$forceUpdate();
      });
      const res = await lectureChatingService.getLectureChating({
        lecture_id: vm.lectureId,
      });
      const discuss = JSON.parse(JSON.stringify(res.data.chatData));
      const dLength = discuss.length;
      for (let i = 0; i < dLength; i += 1) {
        /* if (!(discuss[i].is_teacher === 1 ||
          discuss[i].user_id === utils.getUserIdFromJwt())) {
          delete discuss[i];
        } else { */
        discuss[i].created_at = utils.formatDate(new Date(discuss[i].created_at));
      }
      vm.discuss = discuss;
    },
    beforeUpdate() {
      const vm = this;
      if (vm.pre !== vm.lectureId) {
        vm.pre = vm.lectureId;
        vm.$forceUpdate();
      }
    },
    updated() {
      const vm = this;
      vm.$nextTick(() => {
        const container = vm.$el.querySelector('#chat-wrap');
        container.scrollTop = container.scrollHeight;
      });
    },
    data() {
      return {
        msg: '',
        isStudent: true,
        pre: -1,
        discuss: [],
        limitLength: null,
        dialogVisible: false,
        displaySize: {
          width: undefined,
          height: undefined,
          chatHeight: undefined,
          inputChatWidth: undefined,
        },
        materialVisible: false,
        materialList: undefined, // 강의자료 목록
        portraitOrLandscape: 'Landscape',
      };
    },
    computed: {
      ...mapState('lc', [
        'lecture',
      ]),
      lectureId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.lectureId, 10);
      },
      authType() {
        return utils.getAuthTypeFromJwt2();
      },
    },
    components: {
      RealtimeWebcamLectureStudent,
      LectureLiveMaterial,
    },
    methods: {
      formatDate: utils.formatDate,
      openInNewTab(url) {
        if (!url.match(/^https?:\/\//i)) {
          url = 'http://' + url;
        }
        window.open(url, '_blank').focus();
      },
      async chatSubmit() {
        const vm = this;
        if (!vm.msg.replace('\n', '')) {
          vm.$notify({
            title: '오류',
            message: '내용을 입력해주세요.',
            type: 'warning',
          });
        } else if (utils.getUserIdFromJwt() === null) {
          vm.$notify({
            title: '오류',
            message: '두 개 이상의 창으로 접속했을 경우, 창 하나로만 접속해주세요. 재접속해주세요.',
            type: 'warning',
          });
        } else {
          const params = {
            lecture_id: vm.lectureId,
            user_id: utils.getUserIdFromJwt(),
            content: vm.msg,
          };
          vm.$socket.emit('SEND_NEW_CHAT', JSON.stringify(params));
        }
        vm.updating = true;
        vm.msg = '';
      },
      requestCall() {
        const vm = this;
        // 서버에 신호를 보냄
        vm.$socket.emit('REQUEST_CALL', JSON.stringify({
          lecture_id: vm.lectureId,
          email_from: utils.getEmailFromJwt(),
          user_id_from: utils.getUserIdFromJwt(),
        }));
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('REALTIME.REQUEST'),
          type: 'success',
        });
      },
      // 채팅 내용 삭제
      async deleteChat() {
        const vm = this;
        vm.dialogVisible = false;
        vm.discuss = true;
        await lectureChatingService.deleteLectureChating({
          lecture_id: vm.lectureId,
        });
        vm.$notify({
          title: 'Success',
          message: vm.$t('NOTIFY.DELETE_SUCCESS'),
          type: 'success',
        });
      },
      // 채팅 내용 엑셀로 다운로드
      exportToExcel() {
        const vm = this;
        TableExport(document.getElementById('chat'), {
          formats: ['xlsx'],
          filename: 'chating',
          sheetname: 'chating',
          position: 'top',
        });
        vm.$notify({
          title: 'Info',
          message: vm.$t('NOTIFY.CHAT_DOWN'),
          type: 'info',
        });
      },
      async onClick(type) {
        const vm = this;
        switch (type) {
          case 'MATRIALCHECK': {
            if (vm.materialVisible === false) {
              vm.materialVisible = true;
            } else {
              vm.materialVisible = false;
            }          
            break;
          }
          case 'SGROUP': {
            let routeData = vm.$router.resolve({path: '/a/SGroup' + `/${vm.lectureId}/${vm.$route.query.classId}`});
            window.open(routeData.href, '_blank');     
            break;
          }
        }
      },
      presentMaterial(data) {
        const vm = this;
        vm.materialLink = `https://docs.google.com/gview?url=${data}&embedded=true`;
      },
    },
  };
</script>
